src/Entity/Projet.php
<?php

namespace App\Entity;

use App\Repository\ProjetRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: ProjetRepository::class)]
class Projet
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 100)]
    private $nom;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $line;

    #[ORM\Column(type: 'text', nullable: true)]
    private $description;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $url;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $git;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $image_card;

    #[ORM\OneToMany(mappedBy: 'id_projet', targetEntity: ProjetContent::class)]
    public $projetContents;

    #[ORM\OneToMany(mappedBy: 'id_projet', targetEntity: ProjetTechnos::class)]
    private $projetTechnos;

    public function __construct()
    {
        $this->projetContents = new ArrayCollection();
        $this->projetTechnos = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNom(): ?string
    {
        return $this->nom;
    }

    public function setNom(string $nom): self
    {
        $this->nom = $nom;

        return $this;
    }

    public function getLine(): ?string
    {
        return $this->line;
    }

    public function setLine(?string $line): self
    {
        $this->line = $line;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getUrl(): ?string
    {
        return $this->url;
    }

    public function setUrl(?string $url): self
    {
        $this->url = $url;

        return $this;
    }

    public function getGit(): ?string
    {
        return $this->git;
    }

    public function setGit(?string $git): self
    {
        $this->git = $git;

        return $this;
    }

    public function getImageCard(): ?string
    {
        return $this->image_card;
    }

    public function setImageCard(?string $image_card): self
    {
        $this->image_card = $image_card;

        return $this;
    }

    /**
     * @return Collection<int, ProjetContent>
     */
    public function getProjetContents(): Collection
    {
        return $this->projetContents;
    }

    public function addProjetContent(ProjetContent $projetContent): self
    {
        if (!$this->projetContents->contains($projetContent)) {
            $this->projetContents[] = $projetContent;
            $projetContent->setIdProjet($this);
        }

        return $this;
    }

    public function removeProjetContent(ProjetContent $projetContent): self
    {
        if ($this->projetContents->removeElement($projetContent)) {
            // set the owning side to null (unless already changed)
            if ($projetContent->getIdProjet() === $this) {
                $projetContent->setIdProjet(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, ProjetTechnos>
     */
    public function getProjetTechnos(): Collection
    {
        return $this->projetTechnos;
    }

    public function addProjetTechno(ProjetTechnos $projetTechno): self
    {
        if (!$this->projetTechnos->contains($projetTechno)) {
            $this->projetTechnos[] = $projetTechno;
            $projetTechno->setIdProjet($this);
        }

        return $this;
    }

    public function removeProjetTechno(ProjetTechnos $projetTechno): self
    {
        if ($this->projetTechnos->removeElement($projetTechno)) {
            // set the owning side to null (unless already changed)
            if ($projetTechno->getIdProjet() === $this) {
                $projetTechno->setIdProjet(null);
            }
        }

        return $this;
    }

    public function __toString()
    {
        return $this->nom;
    }
}

templates/adminProjet/_delete_form.html.twig
<form method="post" action="{{ path('app_projet_delete', {'id': projet.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ projet.id) }}">
    <button class="btn">Delete</button>
</form>

templates/adminProjet/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/adminProjet/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Projet{% endblock %}

{% block body %}
    <h1>Edit Projet</h1>

    {{ include('projet/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_projet_index') }}">back to list</a>

    {{ include('projet/_delete_form.html.twig') }}
{% endblock %}

templates/adminProjet/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Projet index{% endblock %}

{% block stylesheets %}
    <link rel="stylesheet" href="{{ asset('css/index.css') }}">
{% endblock %}

{% block body %}
    <h1>Projet index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Nom</th>
                <th>Line</th>
                <th>Description</th>
                <th>Url</th>
                <th>Git</th>
                <th>Image_card</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for projet in projets %}
            <tr>
                <td>{{ projet.id }}</td>
                <td>{{ projet.nom }}</td>
                <td>{{ projet.line }}</td>
                <td>{{ projet.description }}</td>
                <td>{{ projet.url }}</td>
                <td>{{ projet.git }}</td>
                <td>{{ projet.imageCard }}</td>
                <td>
                    <a href="{{ path('app_projet_show', {'id': projet.id}) }}">show</a>
                    <a href="{{ path('app_projet_edit', {'id': projet.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="8">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_projet_new') }}">Create new</a>
{% endblock %}


{% for projet in projets %}
        <a href="{{ projet.id }}">
            <div class="projet-card">
                <img src="{{ projet.imagecard }}" alt="projet {{ projet.nom }}">
                <p>{{ projet.nom }}</p>
                <p>{{ projet.line }}</p>
            </div>
        </a>
    {% else %}
        <p>aucun projet trouvé</p>
    {% endfor %}

templates/adminProjet/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Projet{% endblock %}

{% block body %}
    <h1>Create new Projet</h1>

    {{ include('projet/_form.html.twig') }}

    <a href="{{ path('app_projet_index') }}">back to list</a>
{% endblock %}

templates/adminProjet/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Projet{% endblock %}

{% block body %}
    <h1>Projet</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ projet.id }}</td>
            </tr>
            <tr>
                <th>Nom</th>
                <td>{{ projet.nom }}</td>
            </tr>
            <tr>
                <th>Line</th>
                <td>{{ projet.line }}</td>
            </tr>
            <tr>
                <th>Description</th>
                <td>{{ projet.description }}</td>
            </tr>
            <tr>
                <th>Url</th>
                <td>{{ projet.url }}</td>
            </tr>
            <tr>
                <th>Git</th>
                <td>{{ projet.git }}</td>
            </tr>
            <tr>
                <th>Image_card</th>
                <td>{{ projet.imageCard }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_projet_index') }}">back to list</a>

    <a href="{{ path('app_projet_edit', {'id': projet.id}) }}">edit</a>

    {{ include('projet/_delete_form.html.twig') }}
{% endblock %}